%% Ejemplo 5. Eliminacin de coeficiente  2D DCT

% Leer imagen
I=imread('cameraman.tif'); 

% Seleccion valor threshold
Umbral=-1;
while (Umbral > 1 || Umbral < 0)
    Umbral = input('Introduce un threshold [0.0 1.0]: ');
end

T=dct2(I); % Transformada directa 2D DCT

% Se seleccionan los coeficientes  superiores a un
% umbral. Escala logarmica.
Ts=(log(abs(T)) > Umbral*log(max(max(abs(T))))) .* T;

% Contar coeficientes no nulos. Si su valor es 10000 veces menor al valor
% del coeficiente mximo
Tnn=(abs(T) > max(max(abs(T)))/10000.0);
fprintf('\n Imagen original: coeficientes no nulos  =%d',sum(sum(Tnn)));
Tns=(abs(Ts) > max(max(abs(T)))/10000.0);
fprintf('\n Imagen procesada: coeficientes no nulos =%d',sum(sum(Tns)));

% Se aplica la transformada inversa
Ii=idct2(Ts);

% Visualizacin imgenes y resultados
subplot(2,2,1), imshow(I), title('IMAGEN ORIGINAL');
subplot(2,2,2), imshow(mat2gray(Ii)), title('IMAGEN RECUPERADA');
fprintf('\n PNSR=%f', PSNR(I,Ii));
fprintf('\n');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                                                              %%
%% COMPRESION DE VIDEO                                          %%
%% Grado en Ingeniera de Tecnologas de Telecomunicacin       %%
%% Gustavo A. Ruiz Robredo                                      %%
%% ruizrg@unican.es                                             %%
%%                                                              %%
%% uu   uu  cccccc   UNIVERSIDAD DE CANTABRIA                   %%
%% uu   uu  cccccc   Dpto. INGENIERIA INFORMATICA Y ELECTRONICA %%
%% uu   uu  cc       FACULTAD DE CIENCIAS                       %%
%%  uuuuu   cccccc   Avda. Los Castros s/n                      %%
%%   uuu    cccccc   39005-SANTANDER (SPAIN)                    %%
%%                                                              %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%