%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                                                              %%
%% COMPRESION DE VIDEO                                          %%
%% Grado en Ingeniera de Tecnologas de Telecomunicacin       %%
%% Gustavo A. Ruiz Robredo y Juan A. Michell                    %%
%% ruizrg@unican.es, michellj@unican.es                         %%
%%                                                              %%
%% uu   uu  cccccc   UNIVERSIDAD DE CANTABRIA                   %%
%% uu   uu  cccccc   Dpto. INGENIERIA INFORMATICA Y ELECTRONICA %%
%% uu   uu  cc       FACULTAD DE CIENCIAS                       %%
%%  uuuuu   cccccc   Avda. Los Castros s/n                      %%
%%   uuu    cccccc   39005-SANTANDER (SPAIN)                    %%
%%                                                              %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

quality=78; %% 1 < quality < 100

close all;
fprintf('\n----------------------');
fprintf('\n---  JPEG BASICO   ---');
fprintf('\n----------------------\n');
% Matrices de cuantificacion
q_y = [16  11  10  16  24  40  51  61; ...
    12  12  14  19  26  58  60  55; ...
    14  13  16  24  40  57  69  56; ...
    14  17  22  29  51  87  80  62; ...
    18  22  37  56  68 109 103  77; ...
    24  35  55  64  81 104 113  92; ...
    49  64  78  87 103 121 120 101; ...
    72  92  95  98 112 100 103  99];

q_c = [ 17 18 24 47 99 99 99 99; ...
    18 21 26 66 99 99 99 99; ...
    24 26 56 99 99 99 99 99; ...
    47 66 99 99 99 99 99 99; ...
    99 99 99 99 99 99 99 99; ...
    99 99 99 99 99 99 99 99; ...
    99 99 99 99 99 99 99 99; ...
    99 99 99 99 99 99 99 99 ];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Se lee la imagen
I=Imread('peppers.png');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Conversion RGB -> YcrYcb 4:2:0
RGB=[ 0.299 0.587 0.114; -0.1687 -0.3313 0.5; 0.5 -0.4187 -0.0813];
for x=1:size(I,1)
    for   y=1:size(I,2)
        Ycbcr(x,y,1:3)=RGB*double( [I(x,y,1); I(x,y,2); I(x,y,3)])+ [0; 128; 128];
    end
end

Y0=Ycbcr(:,:,1); %luma
Cb=Ycbcr(:,:,2); % Croma Cb
Cr=Ycbcr(:,:,3); % Croma Cr

% Definicin filtro 'average' 2x2
h = fspecial('average',[2 2]);

% Filtrado de las cromas
Cbh = imfilter(Cb,h,'replicate'); % Filtrado Cr
Crh = imfilter(Cr,h,'replicate'); % Filtrado Cb

% Subsampling 4:2:0
Cb0=Cbh(2:2:size(Cbh,1),2:2:size(Cbh,2));
Cr0=Crh(2:2:size(Crh,1),2:2:size(Crh,2));

close all;
hFig = figure;
set(hFig, 'Position', [20 20 1200 1000]);

% Imagen original
Ired=cat(3,I(:,:,1),zeros(size(I,1),size(I,2)),zeros(size(I,1),size(I,2)));
Igreen=cat(3,zeros(size(I,1),size(I,2)),I(:,:,2),zeros(size(I,1),size(I,2)));
Iblue=cat(3,zeros(size(I,1),size(I,2)),zeros(size(I,1),size(I,2)),I(:,:,3));
subplot(3,3,1), imshow(Ired),title('IMAGEN ORIGINAL: RED');
subplot(3,3,2), imshow(Igreen),title('IMAGEN ORIGINAL: GREEN');
subplot(3,3,3), imshow(Iblue),title('IMAGEN ORIGINAL: BLUE');

% YUV 4:4:4
Cblue=cat(3,zeros(size(Cbh,1),size(Cbh,2)),zeros(size(Cbh,1),size(Cbh,2)),Cbh);
Cred=cat(3,Crh,zeros(size(Crh,1),size(Crh,2)),zeros(size(Crh,1),size(Crh,2)));
subplot(3,3,4), imshow(mat2gray(Y0)),title('IMAGEN ORIGINAL: LUMA');
subplot(3,3,5), imshow(mat2gray(Cblue)),title('IMAGEN ORIGINAL: CB 4:4:4');
subplot(3,3,6), imshow(mat2gray(Cred)), title('IMAGEN ORIGINAL: CR 4:4:4');

% YUV 4:2:0
Cblue0=zeros(size(I,1),size(I,2),3);
Cblue0(1:size(Cb0,1),1:size(Cb0,2),:)=cat(3,zeros(size(Cb0,1),size(Cb0,2)),zeros(size(Cb0,1),size(Cb0,2)),Cb0);
Cred0=zeros(size(I,1),size(I,2),3);
Cred0(1:size(Cr0,1),1:size(Cr0,2),:)=cat(3,Cr0,zeros(size(Cr0,1),size(Cr0,2)),zeros(size(Cr0,1),size(Cr0,2)));
subplot(3,3,7), imshow(mat2gray(Y0)),title('IMAGEN ORIGINAL: LUMA');
subplot(3,3,8), imshow(mat2gray(Cblue0)),title('IMAGEN ORIGINAL: CB 4:2:0');
subplot(3,3,9), imshow(mat2gray(Cred0)), title('IMAGEN ORIGINAL: CR 4:2:0');

disp('Step 1. Conversion RGB -> YcbYcr 4:2:0');
pause
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% 2D DCT para bloques 8x8

% Offset -128
Y1 =int16(Y0)-128;
Cb1=int16(Cb0)-128;
Cr1=int16(Cr0)-128;

% 2D DCT
dct=@(block_struct) dct2( block_struct.data);
Y2=blockproc(Y1,   [8 8], dct);
Cb2=blockproc(Cb1, [8 8], dct);
Cr2=blockproc(Cr1, [8 8], dct);

close(hFig);
hFig = figure;
set(hFig, 'Position', [20 20 1200 1000]);

% Coeficientes DCT
Cblue2=zeros(size(I,1),size(I,2));
Cblue2(1:size(Cb2,1),1:size(Cb2,2))=Cb2;
Cred2=zeros(size(I,1),size(I,2));
Cred2(1:size(Cr2,1),1:size(Cr2,2))=Cr2;
subplot(1,3,1), imshow(im2uint8(1+log(abs(Y2)))),title('COEFICIENTES DCT: LUMA');
subplot(1,3,2), imshow(im2uint8(1+log(abs(Cred2)))),title('COEFICIENTES DCT: CB 4:2:0');
subplot(1,3,3), imshow(im2uint8(1+log(abs(Cred2)))), title('COEFICIENTES DCT: CR 4:2:0');

disp('Step 2. 2D DCT');
pause

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Cuantificacin
% Escalado
if( quality <= 50)
    scale=50/quality;
else
    scale=2-2*quality/100;
end

% Escalado
q_ys=q_y*scale;
q_cs=q_c*scale;

% Cuantificacin
Y3=blockproc (Y2,   [8 8], @(block_struct) round(round( block_struct.data ./ q_ys)) );
Cb3=blockproc (Cb2, [8 8], @(block_struct) round(round( block_struct.data ./ q_cs)) );
Cr3=blockproc (Cr2, [8 8], @(block_struct) round(round( block_struct.data ./ q_cs)) );

close(hFig);
hFig = figure;
set(hFig, 'Position', [20 20 1200 1000]);

% Coeficientes cuantificados DCT
Cblue2=zeros(size(I,1),size(I,2));
Cblue2(1:size(Cb3,1),1:size(Cb3,2))=Cb3;
Cred2=zeros(size(I,1),size(I,2));
Cred2(1:size(Cr3,1),1:size(Cr3,2))=Cr3;
subplot(1,3,1), imshow(im2uint8(1+log(abs(Y3)))),title('CUANTIFICACIN: LUMA');
subplot(1,3,2), imshow(im2uint8(1+log(abs(Cblue2)))),title('CUANTIFICACIN: CB 4:2:0');
subplot(1,3,3), imshow(im2uint8(1+log(abs(Cred2)))), title('CUANTIFICACIN: CR 4:2:0');

disp('Step 3. Cuantificacin');
pause

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Reordenacion zig-zag
% yo = im2col(transpose(y3), [8,8], 'distinct');
% yv = yo(order,:);
disp('Step 4. Codificacin/Decodificacin entrpica Huffman');


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Cuantificacin inversa: Reescalado
Y4=blockproc (Y3,   [8 8], @(block_struct) round(round( block_struct.data .* q_ys)) );
Cb4=blockproc (Cb3, [8 8], @(block_struct) round(round( block_struct.data .* q_cs)) );
Cr4=blockproc (Cr3, [8 8], @(block_struct) round(round( block_struct.data .* q_cs)) );

close(hFig);
hFig = figure;
set(hFig, 'Position', [20 20 1200 1000]);

% Coeficientes cuantificados DCT
Cblue4=zeros(size(I,1),size(I,2));
Cblue4(1:size(Cb4,1),1:size(Cb4,2))=Cb4;
Cred4=zeros(size(I,1),size(I,2));
Cred4(1:size(Cr4,1),1:size(Cr4,2))=Cr4;
subplot(1,3,1), imshow(im2uint8(1+log(abs(Y4)))),title('CUANTIFICACIN INVERSA: LUMA');
subplot(1,3,2), imshow(im2uint8(1+log(abs(Cblue4)))),title('CUANTIFICACIN INVERSA: CB 4:2:0');
subplot(1,3,3), imshow(im2uint8(1+log(abs(Cred4)))), title('CUANTIFICACIN INVERSA: CR 4:2:0');

disp('Step 5. Cuantificacin inversa: Re-escalado');
pause
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% 2D IDCT para bloques 8x8
idct=@(block_struct) idct2(block_struct.data);

Y5=blockproc(Y4,   [8 8], idct);
Cb5=blockproc(Cb4, [8 8], idct);
Cr5=blockproc(Cr4, [8 8], idct);

% Offset
Y6=round(round(Y5))+128;
Cb6=round(round(Cb5))+128;
Cr6=round(round(Cr5))+128;

close(hFig);
hFig = figure;
set(hFig, 'Position', [20 20 1200 1000]);

% Coeficientes cuantificados DCT
Cblue6=zeros(size(I,1),size(I,2));
Cblue6(1:size(Cb6,1),1:size(Cb6,2))=Cb6;
Cred6=zeros(size(I,1),size(I,2));
Cred6(1:size(Cr6,1),1:size(Cr6,2))=Cr6;
subplot(1,3,1), imshow(mat2gray(Y6)),title('IMAGEN RECUPERADA: LUMA');
subplot(1,3,2), imshow(mat2gray(Cblue6)),title('CUANTIFICACIN: CB 4:2:0');
subplot(1,3,3), imshow(mat2gray(Cred6)), title('CUANTIFICACIN: CR 4:2:0');

disp('Step 6. 2D IDCT');
pause

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Conversion RGB -> YcrYcb 4:4:4

% Upsampling cromas. Conversion YCbCr 4:2:0 a 4:4:4
Cb6=imresize(Cb6,2);
Cr6=imresize(Cr6,2);

% Conversion RGB -> YcrYcb 4:2:0
RGBinv=inv(RGB);
for x=1:size(Y6,1)
    for   y=1:size(Y6,2)
        Irec(x,y,1:3)=uint8(RGBinv*( [Y6(x,y); Cb6(x,y); Cr6(x,y)] - [0; 128; 128]));
    end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Analisis comparativo
close(hFig);
compareImagesTool(I,Irec);
imwrite(Irec,'lennaRec.tif');
fprintf('\nFichero de salida (quality=%d): lennaRec.tif', quality);
fprintf('\nPSNR=%f dB',PSNR(I,Irec));
fprintf('\n**********************\n');
